<?php

if(!defined('IN_DISCUZ')) {
	exit('Access Denied');
}

if(empty($_G['uid'])) {
    exit(lang('message', 'not_loggedin'));
}

define('URL_ROOT', strtolower(($_SERVER['HTTPS'] == 'on' ? 'https' : 'http').'://'.$_SERVER['HTTP_HOST'].substr($_SERVER['PHP_SELF'], 0, strrpos($_SERVER['PHP_SELF'], '/'))));

if (submitcheck('formhash')) {
    if (submitcheck('imagesubmit')) {
        $imageurl = $_G['gp_image_url'];
    }
    elseif ($_G['gp_album_pic_url']) {
        $imageurl = $_G['gp_album_pic_url'];
        if (!preg_match('/^https?:\/\//is', $imageurl)) {
            $imageurl = URL_ROOT . '/' . $imageurl;
        }
    }
}

if ($imageurl) {
    if (0 === strpos($imageurl, URL_ROOT . '/')) {
        echo $imageurl;
        exit;
    }

    $tmpdir = DISCUZ_ROOT . './data/tmp/';
    if (!is_dir($tmpdir)) {
        @mkdir($tmpdir, 0777);
		@touch($tmpdir.'/index.html');
    }
    $data = dfsockopen($imageurl);
    if(!$data) {
        exit('Invalid Image Source');
    }
    $tmpfname = tempnam($tmpdir, "AVT");
    if(!$tmpfname) {
        exit('Cannot create temp file');
    }
    @chmod($tmpfname, 0644);
    if (!file_put_contents($tmpfname, $data)) {
        exit('Unable copy image');
    }
    list($width, $height, $type, $attr) = getimagesize($tmpfname);
    if(!in_array($type, array(1,2,3,6))) {
        exit('Invalid image type');
    }
    if($width < 10 || $height < 10 || $type == 4) {
        exit('Invalid file size');
    }
    $imgtype = array(1 => '.gif', 2 => '.jpg', 3 => '.png');
    $filetype = $imgtype[$type];
    if(!$filetype) $filetype = '.jpg';
    $uid = $_G['uid'];
    $tmpavatar = $tmpdir . 'upload'.$uid.$filetype;
    @rename($tmpfname, $tmpavatar);
    $avatarurl = URL_ROOT . '/data/tmp/upload'.$uid.$filetype;
    echo $avatarurl;
}
?>